/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-14 15:32:06 UTC)
 * on 2013-08-19 at 21:23:55 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.prediction.model;

/**
 * Model definition for Insert.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Prediction API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Insert extends com.google.api.client.json.GenericJson {

  /**
   * The unique name for the predictive model.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String id;

  /**
   * Type of predictive model (classification or regression).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String modelType;

  /**
   * The Id of the model to be copied over.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String sourceModel;

  /**
   * Google storage location of the training data file.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String storageDataLocation;

  /**
   * Google storage location of the preprocessing pmml file.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String storagePMMLLocation;

  /**
   * Google storage location of the pmml model file.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String storagePMMLModelLocation;

  /**
   * Instances to train model on.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<TrainingInstances> trainingInstances;

  static {
    // hack to force ProGuard to consider TrainingInstances used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(TrainingInstances.class);
  }

  /**
   * A class weighting function, which allows the importance weights for class labels to be
   * specified (Categorical models only).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.util.Map<String, java.lang.Double>> utility;

  /**
   * The unique name for the predictive model.
   * @return value or {@code null} for none
   */
  public java.lang.String getId() {
    return id;
  }

  /**
   * The unique name for the predictive model.
   * @param id id or {@code null} for none
   */
  public Insert setId(java.lang.String id) {
    this.id = id;
    return this;
  }

  /**
   * Type of predictive model (classification or regression).
   * @return value or {@code null} for none
   */
  public java.lang.String getModelType() {
    return modelType;
  }

  /**
   * Type of predictive model (classification or regression).
   * @param modelType modelType or {@code null} for none
   */
  public Insert setModelType(java.lang.String modelType) {
    this.modelType = modelType;
    return this;
  }

  /**
   * The Id of the model to be copied over.
   * @return value or {@code null} for none
   */
  public java.lang.String getSourceModel() {
    return sourceModel;
  }

  /**
   * The Id of the model to be copied over.
   * @param sourceModel sourceModel or {@code null} for none
   */
  public Insert setSourceModel(java.lang.String sourceModel) {
    this.sourceModel = sourceModel;
    return this;
  }

  /**
   * Google storage location of the training data file.
   * @return value or {@code null} for none
   */
  public java.lang.String getStorageDataLocation() {
    return storageDataLocation;
  }

  /**
   * Google storage location of the training data file.
   * @param storageDataLocation storageDataLocation or {@code null} for none
   */
  public Insert setStorageDataLocation(java.lang.String storageDataLocation) {
    this.storageDataLocation = storageDataLocation;
    return this;
  }

  /**
   * Google storage location of the preprocessing pmml file.
   * @return value or {@code null} for none
   */
  public java.lang.String getStoragePMMLLocation() {
    return storagePMMLLocation;
  }

  /**
   * Google storage location of the preprocessing pmml file.
   * @param storagePMMLLocation storagePMMLLocation or {@code null} for none
   */
  public Insert setStoragePMMLLocation(java.lang.String storagePMMLLocation) {
    this.storagePMMLLocation = storagePMMLLocation;
    return this;
  }

  /**
   * Google storage location of the pmml model file.
   * @return value or {@code null} for none
   */
  public java.lang.String getStoragePMMLModelLocation() {
    return storagePMMLModelLocation;
  }

  /**
   * Google storage location of the pmml model file.
   * @param storagePMMLModelLocation storagePMMLModelLocation or {@code null} for none
   */
  public Insert setStoragePMMLModelLocation(java.lang.String storagePMMLModelLocation) {
    this.storagePMMLModelLocation = storagePMMLModelLocation;
    return this;
  }

  /**
   * Instances to train model on.
   * @return value or {@code null} for none
   */
  public java.util.List<TrainingInstances> getTrainingInstances() {
    return trainingInstances;
  }

  /**
   * Instances to train model on.
   * @param trainingInstances trainingInstances or {@code null} for none
   */
  public Insert setTrainingInstances(java.util.List<TrainingInstances> trainingInstances) {
    this.trainingInstances = trainingInstances;
    return this;
  }

  /**
   * A class weighting function, which allows the importance weights for class labels to be
   * specified (Categorical models only).
   * @return value or {@code null} for none
   */
  public java.util.List<java.util.Map<String, java.lang.Double>> getUtility() {
    return utility;
  }

  /**
   * A class weighting function, which allows the importance weights for class labels to be
   * specified (Categorical models only).
   * @param utility utility or {@code null} for none
   */
  public Insert setUtility(java.util.List<java.util.Map<String, java.lang.Double>> utility) {
    this.utility = utility;
    return this;
  }

  @Override
  public Insert set(String fieldName, Object value) {
    return (Insert) super.set(fieldName, value);
  }

  @Override
  public Insert clone() {
    return (Insert) super.clone();
  }

  /**
   * Model definition for InsertTrainingInstances.
   */
  public static final class TrainingInstances extends com.google.api.client.json.GenericJson {

    /**
     * The input features for this instance.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.util.List<java.lang.Object> csvInstance;

    /**
     * The generic output value - could be regression or class label.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String output;

    /**
     * The input features for this instance.
     * @return value or {@code null} for none
     */
    public java.util.List<java.lang.Object> getCsvInstance() {
      return csvInstance;
    }

    /**
     * The input features for this instance.
     * @param csvInstance csvInstance or {@code null} for none
     */
    public TrainingInstances setCsvInstance(java.util.List<java.lang.Object> csvInstance) {
      this.csvInstance = csvInstance;
      return this;
    }

    /**
     * The generic output value - could be regression or class label.
     * @return value or {@code null} for none
     */
    public java.lang.String getOutput() {
      return output;
    }

    /**
     * The generic output value - could be regression or class label.
     * @param output output or {@code null} for none
     */
    public TrainingInstances setOutput(java.lang.String output) {
      this.output = output;
      return this;
    }

    @Override
    public TrainingInstances set(String fieldName, Object value) {
      return (TrainingInstances) super.set(fieldName, value);
    }

    @Override
    public TrainingInstances clone() {
      return (TrainingInstances) super.clone();
    }

  }

}
